// Course:		CS 14

// Lab Section:		021
// Assignment #:	Assignment 1
//
// First Name:		Jimmy
// Last Name:		Xu
// Login id:		jxu
// email:		jxu@cs.ucr.edu
// Student id:		860-34-2393
// ========================================================

#include <iostream>
#include <string>
#include <cstdio>
#include "phone_book.h"

using namespace std;


//-------------------------------------------------------------------------
// DO NOT MODIFY THIS PRINT FUNCTION

void
PhoneBook::print ( ) {

  if ( head == NULL ) {
    cout << "Phonebook is empty" << endl;
  }
  else {
    for ( AreaNode* temp = head; temp != NULL; temp = temp->next ) {
      cout << "( " << temp->areaCode << " )" << endl;
      temp->print ( );
    }
  }

}

//-------------------------------------------------------------------------

void
PhoneBook::readFromFile ( string fileName ) {

  int area;
  int prefix;
  int suffix;

  fileName = "phone_numbers.txt";
  // initialize pointer to the file
  FILE* pfile;
  // open the file, error check 
  pfile = fopen ( "phone_numbers.txt", "r" );
  if ( pfile == NULL )
    {
      perror ( "Error opening file" );
    }
  // read each phone number in the file and insert it to the phonebook
  // until the end of file, then close the file.
  else
    {     
      while ( ! feof ( pfile ) )
	{
	  fscanf ( pfile, "%d-%d-%d\n", &area, &prefix, &suffix );
	  insertPhoneNumber ( area, prefix, suffix );
	}
      fclose ( pfile );
    }
}

//-------------------------------------------------------------------------
// Constructor
PhoneBook::PhoneBook( ) {

  head = NULL;
}

//-------------------------------------------------------------------------
// Destructor
PhoneBook::~PhoneBook( ) {

  AreaNode* areaPtr;
  NumberNode* numPtr;

  // outer loop deletes all the area codes
  for ( areaPtr = head; areaPtr != NULL; areaPtr = head )
    {
      // inner loop deletes all the phone numbers of that area code
      for ( numPtr = areaPtr->head; numPtr != NULL; numPtr = areaPtr->head )
	{
	  areaPtr->head = numPtr->next;
	  delete numPtr;
	}

      head = areaPtr->next;
      delete areaPtr;
    } 
}

//-------------------------------------------------------------------------

bool
PhoneBook::isNumberFront ( int area, int prefix, int suffix ) {
  
  /**
     check if a number is at the front of the number list in an area code.
     it assumes the number exist.
  **/
  AreaNode* areaPtr;
  NumberNode* numPtr;

  // search the area code list to find the area
  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
    {
      if ( areaPtr->areaCode == area )
	{
	  // then search the number list of the area code to find the number
	  for ( numPtr = areaPtr->head; numPtr != NULL; numPtr = numPtr->next )
	    {
	      if ( numPtr->prefix == prefix && numPtr->suffix == suffix )
		{
		  // finally check if number is at the front of the number list
		  if ( numPtr == areaPtr->head )
		    {
		      return true;
		      break;
		    }
		}
	    }
	  break;
	}
    }

  return false;
}
  
//-------------------------------------------------------------------------

void
PhoneBook::removeAreaCode ( int area ) {

  AreaNode* areaPtr;
  AreaNode* current;
  AreaNode* prev;
  // if phonebook is empty, output error
  if ( head == NULL )
    {
      cout << "Error: Area code does not exist"
	   << endl;
    }

  // if there is phone numbers in that area code list, output error
  else if ( numAreaCodeNumbers ( area ) > 0 )
    {
      cout << "Error: Number exist in area code"
	   << endl;
    }

  // if phone book is not empty and the area code list is empty, do remove
  else
    {
      areaPtr = head;
      // if area code is at the front of the phonebook, remove it from the
      // front
      if ( areaPtr->areaCode == area )
	{
	  head = areaPtr->next;
	  delete areaPtr;
	}
      // if area code is at middle or last of the phonebook, remove it in
      // a general way
      else
	{
	  // set the current pointer to the area node being removed
	  while ( areaPtr != NULL )
	    {
	      if ( areaPtr->areaCode == area )
		{
		  current = areaPtr;
		  break;
		}

	      else
		{
		  areaPtr = areaPtr->next;
		}
	    }

	  // set the prev pointer to one node before the area node being 
	  // removed
	  areaPtr = head;
	  while ( areaPtr != NULL )
	    {
	      if ( areaPtr->next == current )
		{
		  prev = areaPtr;
		  break;
		}

	      else
		{
		  areaPtr = areaPtr->next;
		}
	    }
	  
	  // now, remove the area node in the middle of the list
	  prev->next = current->next;
	  delete current;
	}
    }
}

//-------------------------------------------------------------------------

void
PhoneBook::removePhoneNumber ( int area, int prefix, int suffix ) {

  AreaNode* areaPtr;
  NumberNode* numPtr;
  NumberNode* numPtrCurrent;
  NumberNode* numPtrPrev;

  // if phonebook is empty, output an error
  if ( head == NULL )
    {
      cout << "Error: Phone number does not exist"
	   << endl;
    }

  // if the number exist, check the location of the number (front or middle)
  else if ( search ( area, prefix, suffix ) )
    {
      // if number is at the front of the list, remove it from the front
      if ( isNumberFront ( area, prefix, suffix ) )
	{
	  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
	    {
	      if ( areaPtr->areaCode == area )
		{
		  numPtr = areaPtr->head;
		  areaPtr->head = numPtr->next;
		  delete numPtr;
		  // check if the area code list is empty, if empty, delete
		  // the area node also
		  if ( numAreaCodeNumbers ( area ) == 0 )
		    {
		      removeAreaCode ( area );
		    }
		  break;
		}
	    }
	}
      // if number is not at the front of the list, remove it generally
      else
	{
	  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
	    {
	      if ( areaPtr->areaCode == area )
		{
		  // set the current number node pointer to the matching number
		  numPtr = areaPtr->head;
		  while ( numPtr != NULL )
		    {
		      if ( numPtr->prefix == prefix && 
			   numPtr->suffix == suffix )
			{
			  numPtrCurrent = numPtr;
			  break;
			}

		      else
			{
			  numPtr = numPtr->next;
			}
		    }

		  // set the previous number node pointer to one node before 
		  // the current number node pointer
		  numPtr = areaPtr->head;
		  while ( numPtr != NULL )
		    {
		      if ( numPtr->next == numPtrCurrent )
			{
			  numPtrPrev = numPtr;
			  break;
			}
		      else
			{
			  numPtr = numPtr->next;
			}
		    }
		  
		  // now remove the number in the middle of the list
		  numPtrPrev->next = numPtrCurrent->next;
		  delete numPtrCurrent;
		}
	    }
	}
    }

  // if number does not exist, output error and return
  else
    {
      cout << "Error: Phone number does not exist"
	   << endl;
    }
}

//------------------------------------------------------------------------

bool
PhoneBook::search ( int area, int prefix, int suffix ) {

  AreaNode* areaPtr;
  NumberNode* numPtr;
  
  // if the phone book is empty, return false
  if ( head == NULL )
    {
      return false;
    }
  
  // first check if the same area code is found in list
  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
    {
      if ( areaPtr->areaCode == area )
	{
	  // if area is found, iterate through the list of that area code to 
	  // check if the same prefix and suffix match
	  for ( numPtr = areaPtr->head; numPtr != NULL; 
		numPtr = numPtr->next )
	    {
	      // if area, prefix, and suffix all match, return true
	      if ( numPtr->prefix == prefix && numPtr->suffix == suffix )
		{
		  return true;
		}
	    }
	  break;
	}
      
    }

  return false;

}

//-------------------------------------------------------------------------

bool
PhoneBook::searchArea ( int area ) {

  AreaNode* areaPtr;

  // if the phone book is empty, return false
  if ( head == NULL )
    {
      return false;
    }
  // iterate through the list of area codes, if the area code matches,
  // return true
  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
    {
      if ( areaPtr->areaCode == area )
	{
	  return true;
	}
    }

  return false;
}
  
//-------------------------------------------------------------------------
void
PhoneBook::insertPhoneNumber ( int area, int prefix, int suffix ) {

  AreaNode* areaPtr;

  /** 
      dynamically allocate a new number node and set the prefix and suffix
      of the node to the new number's prefix and suffix
  */
  NumberNode* newNumber = new NumberNode;
  newNumber->prefix = prefix;
  newNumber->suffix = suffix;

  //check if the number exist, if exist, output error
  if ( search ( area, prefix, suffix )  )
    {
      cout << "Error: cannot insert duplicate phone numbers"
	   << endl;
    }

  /**
     if the phone number does not exist and the  area code exist, insert 
     number to the head of the list of a area code, set next ptr of the new 
     node to the node after the head, then set the node after the head to 
     the new node
   */
  else if ( ! ( search ( area, prefix, suffix ) )
	    && searchArea ( area ) )
    {
      for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
	{
	  if ( areaPtr->areaCode == area )
	    {
	      newNumber->next = areaPtr->head;
	      areaPtr->head = newNumber;
	      break;
	    }
	}
    }

  /**
     if the phone number exist and the area code did not exist, create a new 
     area code node dynamically and insert it to the front of the area code 
     list. Set the next pointer of the new area code to the head, and make the 
     new head equal to the new area code node.
  */
  else if ( ! ( search ( area, prefix, suffix ) || searchArea ( area ) ) )
    { 
      AreaNode* newAreaCode = new AreaNode;
      newAreaCode->areaCode = area;

      newAreaCode->next = head;
      head = newAreaCode;
      
      // Now, add the number to the new area code, there should be only one
      // number in new area code
      for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
	{
	  if ( areaPtr->areaCode == newAreaCode->areaCode ) 
	    {
	      newNumber->next = areaPtr->head;
	      areaPtr->head = newNumber;
	      break;
	    }
	}
    }
}

//-------------------------------------------------------------------------

int 
PhoneBook::numNumbers ( ) {

  /**
     iterate through the area code list, and at each area code, 
     call the size function to determine the number of phone numbers in that 
     area code and add it to the size counter. Then add up all the phone 
     numbers in all the area codes.
  */
  
  AreaNode* areaPtr;
  int size = 0;
  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
    {
      size += areaPtr->size( );
    }

  return size;
}

//-------------------------------------------------------------------------

int
PhoneBook::numAreaCodeNumbers ( int area ) {

  AreaNode* areaPtr;
  int size = 0;
  // iterate through the area code list to find the area code that matches 
  // this area
  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
    {
      // if area code matches,  call the size( ) function in that area code 
      // and add it to the size counter
      if ( areaPtr->areaCode == area )
	{
	  size = areaPtr->size ( );
	  break;
	}
    }

  return size;
}

//-------------------------------------------------------------------------

int
PhoneBook::numAreaCodeAndPrefixNumbers ( int area , int prefix ) {

  int size = 0;
  AreaNode* areaPtr;
  NumberNode* numPtr;

  // first iterate through the area code to find the area code that matches
  for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
    {
      if ( areaPtr->areaCode == area )
	{
	  // then iterate through that area code's list of numbers to find 
	  // the given prefix
	  for ( numPtr = areaPtr->head; numPtr != NULL; numPtr = numPtr->next )
	    {
	      // everytime a prefix matches, increment the counter
	      if ( numPtr->prefix == prefix )
		{
		  size++;
		}
	    }
	  break;
	}
    }

  return size;
}

//-------------------------------------------------------------------------

void
PhoneBook::split ( int oldAreaCode, int prefix, int newAreaCode ) {

  // check if old area codes or prefix does not exist, output error
  if ( ! searchArea ( oldAreaCode ) ||
       numAreaCodeAndPrefixNumbers ( oldAreaCode, prefix ) == 0 )
    {
      // *note: this does not make sense, i tried to output the error
      // message to say the prefix not exist, but the instructor's
      // output says this messsage:
      cout << "Error: new area code already exists"
	   << endl;
    }

  // if new area code exist, output error
  else if ( searchArea ( newAreaCode ) )
    {
      cout << "Error: new area code already exists"
	   << endl;
    }

  // if old area code exist and new areacode not exist:
  else
    {
      AreaNode* areaPtr;
      NumberNode* numPtr;

      // iterate through area code list to find the old area code
      for ( areaPtr = head; areaPtr != NULL; areaPtr = areaPtr->next )
	{
	  if ( areaPtr->areaCode == oldAreaCode )
	    {
	      // iterate through number list of the old area code to find
	      // the matching prefix numbers
	      for ( numPtr = areaPtr->head; numPtr != NULL; 
		    numPtr = numPtr->next )
		{
		  if ( numPtr->prefix == prefix )
		    {
		      insertPhoneNumber ( newAreaCode, prefix, numPtr->suffix );
		      removePhoneNumber ( oldAreaCode, prefix, numPtr->suffix );
		    }
		}
	      break;
	    }
	}
    }
}

//-------------------------------------------------------------------------
