#!/bin/bash

if [ -z "$2" ] ; then
    echo "usage:"
    echo "convertPDF.sh: DIR PDF"
    echo "Convert PDF into individually named PNG files at about 600x800"
    echo "in directory DIR."
    exit 1
fi

DIR=$1
PDF=$2

TEMP=`dirname \`dirname $2\``
USERNAME=`basename $TEMP`

cd $DIR
BN=`basename $PDF .pdf`
rm -f *.ppm

pdftoppm -r 75 `basename $PDF` $BN
NUM=`ls *.ppm | wc -l`
NUM=`basename $NUM`

for ((i=1;i<=$NUM ;i++)) ; do
    mv ${BN}-`printf "%06d" $i`.ppm ${USERNAME}-${i}.ppm
done

echo $NUM

